#include <M5StickC.h>
#define LGFX_AUTODETECT // 自動認識(D-duino-32 XS, PyBadgeはパネルID読取れないため自動認識の対象から外れているそうです)
#define LGFX_USE_V1     // v1.0.0を有効に(v0からの移行期間の特別措置とのこと。書かない場合は旧v0系で動作)
#include <LovyanGFX.hpp>          // lovyanGFXのヘッダを準備
#include <LGFX_AUTODETECT.hpp>    // クラス"LGFX"を準備
static LGFX lcd; 
static LGFX_Sprite canvas(&lcd);  // スプライトを使うためのLGFX_Spriteのインスタンスを作成

int WIDTH=160;
int HEIGHT=80;
int PX0=0;
int PY0=0;
int WL=16;
int HL=16;
int WS=12;
int HS=12;
int FL=16;
int FS=12;
int nflag1=0;
int nflag2=0;
int sw1=1;
int sw2=1;
int readData=0;
String notice1="";
String notice2="";
String item[22][10]={// 項目名データ　福岡（油須原ゆずばる駅）
    {"先発"},
    {"　　　　　","行橋　行き","直方　行き","金田　行き","回送　　　","当駅止まり"},
    {"０","１","２"},
    {"０","１","２","３","４","５","６","７","８","９"},
    {"０","１","２","３","４","５"},
    {"０","１","２","３","４","５","６","７","８","９"},
    {"次発"},
    {"　　　　　","行橋　行き","直方　行き","金田　行き","回送　　　","当駅止まり"},
    {"０","１","２"},
    {"０","１","２","３","４","５","６","７","８","９"},
    {"０","１","２","３","４","５"},
    {"０","１","２","３","４","５","６","７","８","９"},
    {"後発"},
    {"　　　　　","行橋　行き","直方　行き","金田　行き","回送　　　","当駅止まり"},
    {"０","１","２"},
    {"０","１","２","３","４","５","６","７","８","９"},
    {"０","１","２","３","４","５"},
    {"０","１","２","３","４","５","６","７","８","９"},
    {"　　　　　　　　　　　　　","現在列車は正常に運行中です","列車が到着します　　　　　","列車が発車します　　　　　",
    "列車が通過します　　　　　","列車が遅延しています　　　","列車が運休しています　　　","地震で運転を見合わせ中です"},
    {"　　　　　　　　　　　　　","△印で２列にお並びください","黄線の内側におさがり下さい","駆け込み乗車はご遠慮下さい"}
};
// 初期設定 ----------------------------------------------------------
void setup() {
  Serial.begin(115200);
  M5.begin();
  //LCD初期設定
  lcd.init();
  lcd.setRotation(1);
  // 表示画面初期化
  canvas.setTextWrap(false);                      // 右端到達時のカーソル折り返しを禁止(true)で許可
  canvas.createSprite(lcd.width(), lcd.height()); // スプライト用の仮想画面を画面幅を取得して準備
  // 表示画面処理（メモリ描画領域canvasに描画）
  canvas.fillScreen(TFT_BLACK);    // 背景塗り潰し
  // タイトル表示
  canvas.setFont(&fonts::lgfxJapanGothic_16);     // ゴシック体（8,12,16,20,24,28,32,36,40）
  canvas.setTextColor(TFT_WHITE,TFT_BLUE);        // 文字色と背景を指定（文字色, 背景）
  canvas.setCursor(8, 0);                         // 座標を指定（x, y）
  canvas.print("油須原 発車時刻案内");                // 表示内容をcanvasに準備
  // IPアドレス表示
  canvas.setTextColor(TFT_BLACK,TFT_WHITE);
  canvas.setCursor(8, 24);
  canvas.print("UART通信");
  canvas.setFont(&fonts::lgfxJapanGothic_12);
  canvas.setTextColor(TFT_BLACK,TFT_RED);
  canvas.setCursor(8, HL*3);
  canvas.print("M5ボタンを押して受信開始");
  // 著作権
  canvas.setTextColor(TFT_BLACK,TFT_GREEN);
  canvas.setCursor(8, HL*4); 
  canvas.print("浅見デジタルコンテンツ研");
  canvas.pushSprite(0, 0);    // メモリ内に描画したcanvasを座標を指定して表示する
  while(!M5.BtnA.wasPressed()){
    M5.update();
  }
  lcd.fillScreen(TFT_BLACK);
  lcd.setFont(&fonts::lgfxJapanGothic_16);
  lcd.setTextColor(TFT_WHITE,TFT_RED);
  lcd.setCursor(8, HL*2);
  lcd.print("発車時刻受信待機中");
  delay(100);
  //Serial.println("M5-Aボタンを押しました");
  pinMode(10,OUTPUT);
  digitalWrite(10,HIGH);
}
char code[255];
int len;

// データ受信　--------------------------------------------------------
void loop() {
  len=0;
  memset(code, 0, 50);
  while(Serial.available()){
    char inChar=char(Serial.read());
    code[len]=inChar;
    len++;
    if (len==30) break;
  }
  delay(100);
  if (len==30){
    digitalWrite(10,LOW);
    String strCode=code;
    canvas.fillScreen(TFT_BLACK);    // 背景塗り潰し
    canvas.setFont(&fonts::lgfxJapanGothic_16);
    canvas.setTextColor(TFT_WHITE,TFT_RED); // 先発
    canvas.setCursor(PX0,PY0);
    canvas.print(item[0][strCode.substring(0,1).toInt()]);  
    canvas.setTextColor(TFT_BLACK,TFT_CYAN); // 行先
    canvas.setCursor(PX0+WL*2,PY0);
    canvas.print(item[1][strCode.substring(1,2).toInt()]);
    canvas.setTextColor(TFT_BLACK,TFT_WHITE); // 発車時刻
    canvas.setCursor(PX0+WL*7,PY0);
    canvas.print(strCode.substring(2,4)+":"+strCode.substring(4,6));
    canvas.setTextColor(TFT_WHITE,TFT_BLUE); // 次発
    canvas.setCursor(PX0,PY0+HL);
    canvas.print(item[6][strCode.substring(6,7).toInt()]);
    canvas.setTextColor(TFT_BLACK,TFT_CYAN); // 行先
    canvas.setCursor(PX0+WL*2,PY0+HL);
    canvas.print(item[7][strCode.substring(7,8).toInt()]);
    canvas.setTextColor(TFT_BLACK,TFT_WHITE); // 発車時刻
    canvas.setCursor(PX0+WL*7,PY0+HL);    
    canvas.print(strCode.substring(8,10)+":"+strCode.substring(10,12));   
    canvas.setTextColor(TFT_WHITE,TFT_DARKGREEN); // 後発
    canvas.setCursor(PX0,PY0+HL*2);
    canvas.print(item[12][strCode.substring(12,13).toInt()]);
    canvas.setTextColor(TFT_BLACK,TFT_CYAN);
    canvas.setCursor(PX0+WL*2,PY0+HL*2);
    canvas.print(item[13][strCode.substring(13,14).toInt()]);
    canvas.setTextColor(TFT_BLACK,TFT_WHITE); // 発車時刻
    canvas.setCursor(PX0+WL*7,PY0+HL*2);
    canvas.print(strCode.substring(14,16)+":"+strCode.substring(16,18));
    canvas.setFont(&fonts::lgfxJapanGothic_12); 
    canvas.setTextColor(TFT_RED,TFT_BLACK); // お知らせ１
    canvas.setCursor(PX0,PY0+HL*3);
    nflag1=strCode.substring(23,24).toInt();
    notice1=item[18][strCode.substring(18,19).toInt()]+"　　　";
    canvas.print(notice1); 
    canvas.setTextColor(TFT_YELLOW,TFT_BLACK); // お知らせ２  
    canvas.setCursor(PX0,PY0+HL*4);
    nflag2=strCode.substring(29,30).toInt();
    canvas.print(item[19][strCode.substring(24,25).toInt()]);
    notice2=item[19][strCode.substring(24,25).toInt()]+"　　　";
    canvas.print(notice2);
    canvas.pushSprite(0, 0);
    readData=1;
    delay(500);
    digitalWrite(10,HIGH);
  }
  if (nflag1==1 && readData==1){
    canvas.setTextColor(TFT_RED,TFT_BLACK);
    canvas.setCursor(PX0,PY0+HL*3);
    canvas.print(notice1);
    notice1=notice1.substring(3,notice1.length())+notice1.substring(0,3);
    canvas.pushSprite(0, 0);
    delay(300);
  }
  if (nflag1==2 && readData==1){
    if (sw1==1){
      canvas.setTextColor(TFT_RED,TFT_BLACK);
    } else {
      canvas.setTextColor(TFT_BLACK,TFT_BLACK);
    }
    canvas.setCursor(PX0,PY0+HL*3);
    canvas.print(notice1);
    canvas.pushSprite(0, 0);
    delay(300);
    sw1=1-sw1;
  }  
  if (nflag2==1 && readData==1){  
    canvas.setTextColor(TFT_YELLOW,TFT_BLACK);
    canvas.setCursor(PX0,PY0+HL*4);
    canvas.print(notice2);
    notice2=notice2.substring(3,notice2.length())+notice2.substring(0,3);
    canvas.pushSprite(0, 0);
    delay(300);
  } 
  if (nflag2==2 && readData==1){
    if (sw2==1){
      canvas.setTextColor(TFT_YELLOW,TFT_BLACK);
    } else {
      canvas.setTextColor(TFT_BLACK,TFT_BLACK);
    }   
    canvas.setCursor(PX0,PY0+HL*4);
    canvas.print(notice2);
    canvas.pushSprite(0, 0);
    delay(300);
    sw2=1-sw2;
  }
}
