#PC_udp_senter.py
# Asami Digital Contents Laboratory (Toshiyuki Asami)

from __future__ import print_function
import socket
import time
from contextlib import closing
from pygame.locals import *
import pygame
import sys
import os
FONT_PATH="ipag.ttf" # 表示したいフォントファイル（ここではIPAゴシック）をソースコードと同じフォルダに置く
DEBUG=1
currentTime="0534"
startTime="0544"
startTrain=0
INTERVAL=2000  # １分間を(INTERVAL)ミリ秒で進める

pygame.init()    # Pygameを初期化
pygame.display.set_caption("平成筑豊鉄道　油須原　列車時刻案内板")    # タイトルを作成

SCREEN = pygame.display.set_mode((800, 400))    # 画面を作成
FONT = pygame.font.Font(FONT_PATH, 32)

BLACK = pygame.Color(0,0,0)
RED   = pygame.Color(255,0,0)
WHITE = pygame.Color(255, 255, 255)
BLUE  = pygame.Color(0,0,255)
GREEN = pygame.Color(0,255,0)
FUCHSIA = pygame.Color(255,0,255)
YELLOW= pygame.Color(255,255,0)
ORANGE= pygame.Color(238,120,0)
AQUA  = pygame.Color(0,255,255)
LIME  = pygame.Color(0,255,0)

WL=32
HL=32
FL=32
WS=24
HS=24
FS=24
PS=4
PH=20
PX0=15
PY0=80

sw1=1
sw2=1

notice1=""
notice2=""
textColor1=WHITE
buttonColor1=BLACK
textColor2=WHITE
buttonColor2=BLACK

snum=0
zen=["０","１","２","３","４","５","６","７","８","９"]
index=[0 for i in range(41)]
code=["","","","",""]
opeList=[]
item=[  # 項目名データ
    ["　　　　　　"],#0
    ["現在時刻　　 "],
    ["自動案内表示","手動案内表示"],
    ["先発"],#3
    ["　　　　　","行橋　行き","直方　行き","金田　行き","回送　　　","当駅止まり"],
    ["０","１","２"],
    ["０","１","２","３","４","５","６","７","８","９"],
    ["："],
    ["０","１","２","３","４","５"],
    ["０","１","２","３","４","５","６","７","８","９"],
    ["　　　　　　"],
    ["次発"],#11
    ["　　　　　","行橋　行き","直方　行き","金田　行き","回送　　　","当駅止まり"],
    ["０","１","２"],
    ["０","１","２","３","４","５","６","７","８","９"],
    ["："],
    ["０","１","２","３","４","５"],
    ["０","１","２","３","４","５","６","７","８","９"],
    ["　　　　　　"],
    ["後発"],#19
    ["　　　　　","行橋　行き","直方　行き","金田　行き","回送　　　","当駅止まり"],
    ["０","１","２"],
    ["０","１","２","３","４","５","６","７","８","９"],
    ["："],
    ["０","１","２","３","４","５"],
    ["０","１","２","３","４","５","６","７","８","９"],
    ["　　　　　　"],#26
    ["　　　　　　　　　　　　　","現在列車は正常に運行中です","列車が到着します　　　　　","列車が発車します　　　　　","列車が通過します　　　　　","列車が遅延しています　　　","列車が運休しています　　　","地震で運転を見合わせ中です"],#28
    ["　　　　　　"],#28 
    ["静止","連続","点滅"],#29
    ["　　　　　　　　　　　　　","△印で２列にお並びください","黄線の内側におさがり下さい","駆け込み乗車はご遠慮下さい"],#30
    ["　　　　　　"],#31
    ["静止","連続","点滅"],#32
    ["発車番号＋"],#33
    ["発車番号ー"],
    ["自動／手動"],
    ["手動　送信"],#36
    ["　　"],["　　"],["　　"],["発車# 　"]
]

msgPos=[3,4,5,6,8,9,11,12,13,14,16,17,19,20,21,22,24,25,27,-1,-1,-1,-1,29,30,-1,-1,-1,32]
mcode=""          
codePos=[10,18,26,28,31]
activeButton=[4,5,6,8,9,12,13,14,16,17,20,21,22,24,25,27,29,30,32,33,34,35,36]
buttonColor=[
    BLUE,AQUA,YELLOW,
    RED,WHITE,WHITE,WHITE,WHITE,WHITE,WHITE,ORANGE,
    BLUE,WHITE,WHITE,WHITE,WHITE,WHITE,WHITE,ORANGE,
    LIME,WHITE,WHITE,WHITE,WHITE,WHITE,WHITE,ORANGE,
    FUCHSIA,ORANGE,WHITE,
    YELLOW,ORANGE,WHITE,
    WHITE,WHITE,WHITE,WHITE,
    WHITE,WHITE,WHITE,WHITE
]
textColor=[
    WHITE,BLACK,RED,
    WHITE,BLACK,BLACK,BLACK,BLACK,BLACK,BLACK,WHITE,
    WHITE,BLACK,BLACK,BLACK,BLACK,BLACK,BLACK,WHITE,
    BLACK,BLACK,BLACK,BLACK,BLACK,BLACK,BLACK,WHITE,
    BLACK,WHITE,BLACK,
    BLACK,WHITE,BLACK,
    BLACK,BLACK,BLACK,RED,
    BLACK,BLACK,BLACK,RED
]

buttonRect=[
    #ROW0,index0
    Rect(PX0,PY0,WL*6,HL),
    Rect(PX0+WL*6+PS*3,PY0,WL*6,HL),
    Rect(PX0+WL*13+PS,PY0,WL*6,HL),    
    #ROW1,index4
    Rect(PX0,PY0+HL+PS,WL*2,HL),
    Rect(PX0+WL*2+PS,PY0+HL+PS,WL*5,HL),
    Rect(PX0+WL*7+PS*3,PY0+HL+PS,WL,HL),
    Rect(PX0+WL*8+PS*4,PY0+HL+PS,WL,HL),
    Rect(PX0+WL*9+PS*5,PY0+HL+PS,WL,HL),
    Rect(PX0+WL*10+PS*6,PY0+HL+PS,WL,HL),
    Rect(PX0+WL*11+PS*7,PY0+HL+PS,WL,HL),
    Rect(PX0+WL*12+PS*9,PY0+HL+PS,WL*6,HL),
    #ROW2,index12
    Rect(PX0,PY0+(HL+PS)*2,WL*2,HL),
    Rect(PX0+WL*2+PS,PY0+(HL+PS)*2,WL*5,HL),
    Rect(PX0+WL*7+PS*3,PY0+(HL+PS)*2,WL,HL),
    Rect(PX0+WL*8+PS*4,PY0+(HL+PS)*2,WL,HL),
    Rect(PX0+WL*9+PS*5,PY0+(HL+PS)*2,WL,HL),
    Rect(PX0+WL*10+PS*6,PY0+(HL+PS)*2,WL,HL),
    Rect(PX0+WL*11+PS*7,PY0+(HL+PS)*2,WL,HL),
    Rect(PX0+WL*12+PS*9,PY0+(HL+PS)*2,WL*6,HL),
    #ROW3,index20
    Rect(PX0,PY0+(HL+PS)*3,WL*2,HL),
    Rect(PX0+WL*2+PS,PY0+(HL+PS)*3,WL*5,HL),
    Rect(PX0+WL*7+PS*3,PY0+(HL+PS)*3,WL,HL),
    Rect(PX0+WL*8+PS*4,PY0+(HL+PS)*3,WL,HL),
    Rect(PX0+WL*9+PS*5,PY0+(HL+PS)*3,WL,HL),
    Rect(PX0+WL*10+PS*6,PY0+(HL+PS)*3,WL,HL),
    Rect(PX0+WL*11+PS*7,PY0+(HL+PS)*3,WL,HL),
    Rect(PX0+WL*12+PS*9,PY0+(HL+PS)*3,WL*6,HL),
    #ROW4,inxex27
    Rect(PX0,PY0+(HL+PS)*4+PH,WL*13,FL),
    Rect(PX0+WL*13+PS,PY0+(HL+PS)*4+PH,WL*6,FL),
    Rect(PX0+WL*19+PS*4,PY0+(HL+PS)*4+PH,WL*2,FL),    
    #ROW5,index30
    Rect(PX0,PY0+(HL+PS)*5+PH,WL*13,FL),
    Rect(PX0+WL*13+PS,PY0+(HL+PS)*5+PH,WL*6,FL),
    Rect(PX0+WL*19+PS*4,PY0+(HL+PS)*5+PH,WL*2,FL),
    #ROW6,index33
    Rect(PX0,PY0+(HL+PS)*6+PH*2,WL*5,FL),
    Rect(PX0+WL*5+PS*4,PY0+(HL+PS)*6+PH*2,WL*5,FL),
    Rect(PX0+WL*10+PS*8,PY0+(HL+PS)*6+PH*2,WL*5,FL),
    Rect(PX0+WL*15+PS*12,PY0+(HL+PS)*6+PH*2,WL*5,FL), 

    Rect(PX0+WL*18+PS*12,PY0+HL+PS,WL*2,FL),     #index37
    Rect(PX0+WL*18+PS*12,PY0+(HL+PS)*2,WL*2,FL), #index38
    Rect(PX0+WL*18+PS*12,PY0+(HL+PS)*3,WL*2,FL), #index39
    Rect(PX0+WL*18+PS*12,PY0,WL*4,HL)            #index40
]

def drawLabel(n):
    img = FONT.render(item[n][index[n]],True,textColor[n],buttonColor[n])
    SCREEN.blit(img,buttonRect[n].topleft)
    pygame.display.update()
    
def indexUpdate(n):
    if index[n]<len(item[n])-1:
        index[n]=index[n]+1
    else:
        index[n]=0
    if 4<=n and n<=9:
        code[0]=str(index[3])+str(index[4])+str(index[5])+str(index[6])+str(index[8])+str(index[9])
        item[10][0]=zen[index[3]]+zen[index[4]]+zen[index[5]]+zen[index[6]]+zen[index[8]]+zen[index[9]]
        drawLabel(10)
    elif 12<=n and n<=17:
        code[1]=str(index[11])+str(index[12])+str(index[13])+str(index[14])+str(index[16])+str(index[17])
        item[18][0]=zen[index[11]]+zen[index[12]]+zen[index[13]]+zen[index[14]]+zen[index[16]]+zen[index[17]]
        drawLabel(18)
    elif 20<=n and n<=25:
        code[2]=str(index[19])+str(index[20])+str(index[21])+str(index[22])+str(index[24])+str(index[25])
        item[26][0]=zen[index[19]]+zen[index[20]]+zen[index[21]]+zen[index[22]]+zen[index[24]]+zen[index[25]]
        drawLabel(26)
    elif n==27 or n==29:
        code[3]=str(index[27])+"0000"+str(index[29])
        item[28][0]=zen[index[27]]+"００００"+zen[index[29]]
        drawLabel(28)
            
    elif n==30 or n==32:
        code[4]=str(index[30])+"0000"+str(index[32])
        item[31][0]=zen[index[30]]+"００００"+zen[index[32]]       
        drawLabel(31)
    drawLabel(n)

def drawGuide1(n):
    if n>=len(opeList): return
    index[4]=int(opeList[n][0])
    index[5]=int(opeList[n][1])
    index[6]=int(opeList[n][2])
    index[8]=int(opeList[n][3])
    index[9]=int(opeList[n][4])
    code[0]="0"+opeList[n]
    for i in [4,5,6,8,9]:
        drawLabel(i)
    zencode="０"
    for j in range(5):
        zencode+=zen[int(opeList[n][j])]
    item[codePos[0]][0]=zencode
    drawLabel(codePos[0])

def drawGuide2(n):
    if n>=len(opeList): return
    index[12]=int(opeList[n][0])
    index[13]=int(opeList[n][1])
    index[14]=int(opeList[n][2])
    index[16]=int(opeList[n][3])
    index[17]=int(opeList[n][4])
    code[1]="0"+opeList[n]
    for i in [12,13,14,16,17]:
        drawLabel(i) 
    zencode="０"
    for j in range(5):
        zencode+=zen[int(opeList[n][j])]
    item[codePos[1]][0]=zencode
    drawLabel(codePos[1])

def drawGuide3(n):
    if n>=len(opeList): return
    index[20]=int(opeList[n][0])
    index[21]=int(opeList[n][1])
    index[22]=int(opeList[n][2])
    index[24]=int(opeList[n][3])
    index[25]=int(opeList[n][4])
    code[2]="0"+opeList[n]
    for i in [20,21,22,24,25]:
        drawLabel(i)
    zencode="０"
    for j in range(5):
        zencode+=zen[int(opeList[n][j])]
    item[codePos[2]][0]=zencode
    drawLabel(codePos[2])
    
def operationLoad():
    global opeList
    fn="opelist.txt"
    print(fn)
    f=open(fn,'r')
    opeList=[]
    for x in f:
        opeList.append(x.rstrip("\n"))
    f.close()
    print("発車時刻表を読み込みました")
    if DEBUG==1: print(opeList)


def cycle(cstr):
    cstr=cstr[1:len(cstr)]+cstr[0:1]
    return cstr

def drawText(text,pos,textcolor,backcolor):
    img=FONT.render(text,True,textcolor,backcolor)
    SCREEN.blit(img,pos)
    pygame.display.update()

def drawCurrentTime():
    global currentTime
    hh=int(currentTime[0:2])
    mm=int(currentTime[2:4])
    currentTime="{:0>2d}{:0>2d}".format(hh,mm)
    drawText("現在時刻"+currentTime[0:2]+':'+currentTime[2:4],buttonRect[1].topleft,textColor[1],buttonColor[1])

def nextTime(tstr1):
    hh=int(tstr1[0:2])
    mm=int(tstr1[2:4])
    tt=(hh*60+mm+1) % 1440
    hh=tt // 60
    mm=tt % 60
    tstr2="{:0>2d}{:0>2d}".format(hh,mm)
    return tstr2

def adjustTime():
    global currentTime
    if len(code[0]) != 6 : return
    print("for adust time,",code[0])
    hh=int(code[0][2:4])
    mm=int(code[0][4:6])
    tt=(hh*60+mm-10) % 1440
    hh=tt // 60
    mm=tt % 60
    currentTime="{:0>2d}{:0>2d}".format(hh,mm)
    return

def updateCurrentTime():
    global currentTime
    currentTime=nextTime(currentTime)
    drawText("現在時刻"+currentTime[0:2]+':'+currentTime[2:4],buttonRect[1].topleft,textColor[1],buttonColor[1])

def drawCurrentTrain(n):
    global stratTrain,startTime
    startTrain=n
    startTime=opeList[n][1:5]
    if DEBUG==1: print("先発列車",startTrain,startTime)
    drawText("先発列車#{:0>3d}".format(n),buttonRect[0].topleft,textColor[0],buttonColor[0])
    drawText("#{:0>3d}".format(n),buttonRect[37].topleft,textColor[37],buttonColor[37])
    drawText("#{:0>3d}".format(n+1),buttonRect[38].topleft,textColor[38],buttonColor[38])
    drawText("#{:0>3d}".format(n+2),buttonRect[39].topleft,textColor[39],buttonColor[39])

def drawTrainNumber(n,index):
    if n>38 : return
    drawText("発車#{:0>3d}".format(n),buttonRect[index].topleft,textColor[index],buttonColor[index])
    
operationLoad()
drawText("平成筑豊鉄道田川線 油須原ゆすばる駅 発車時刻案内",(PX0,PY0-55),BLACK,GREEN)


for i in range(len(buttonRect)):
    drawLabel(i)
drawCurrentTime()
drawGuide1(snum)
drawGuide2(snum+1)
drawGuide3(snum+2)
drawCurrentTrain(snum)
adjustTime()

host = '***.***.***.***' # 送信先のM5SickCのWiFiのIPアドレスに書き換える!!!
port = 2000 # ポート番号（送信先のM5SickCで設定済のもの）
sock = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
with closing(sock):
    EVENT1=pygame.USEREVENT    # 静止、連続(スクロール)、点滅(ブリンク)用
    EVENT2=pygame.USEREVENT+1  # 仮想時計用 
    pygame.time.set_timer(EVENT1, 500)
    pygame.time.set_timer(EVENT2, INTERVAL)
    clock=pygame.time.Clock()
    
    while True:           
        for event in pygame.event.get():
            if event.type == QUIT:
                pygame.quit()
                sys.exit()
            if event.type==EVENT1:
                if index[2]==1:
                    if index[29]==1:
                        notice1=cycle(notice1)
                    if index[29]==2:
                        if sw1==1:
                            textColor1=textColor[27]
                            buttonColor1=buttonColor[27]
                        else:
                            textColor1=buttonColor[27]
                            buttonColor1=buttonColor[27]
                        sw1=1-sw1
                    if index[32]==1:
                        notice2=cycle(notice2)
                    if index[32]==2:
                        if sw2==1:
                            textColor2=textColor[30]
                            buttonColor2=buttonColor[30]
                        else:
                            textColor2=buttonColor[30]
                            buttonColor2=buttonColor[30]
                        sw2=1-sw2
                    drawText(notice1[0:13],buttonRect[27].topleft,textColor1,buttonColor1)
                    drawText(notice2[0:13],buttonRect[30].topleft,textColor2,buttonColor2)
            if event.type==EVENT2:
                updateCurrentTime() 
                if DEBUG==1:
                    print(currentTime)
                pygame.time.wait(200)
                if currentTime==startTime and index[2]==0:
                    print("#{:0>3d}".format(snum)+"列車が発車します")
                    index[27]=1
                    drawTrainNumber(snum,40)
                    drawLabel(27)
                    index[30]=1
                    drawLabel(30)
                    item[28][0]="１００００１"
                    drawLabel(28)
                    code[3]="100001"
                    item[31][0]="１００００１"
                    drawLabel(31)
                    code[4]="100001"
                    if snum<len(opeList)-3:
                        snum+=1
                        drawCurrentTrain(snum)
                        drawGuide1(snum)
                        drawGuide2(snum+1)
                        drawGuide3(snum+2)
                    mcode=""
                    for j in range(5):
                        mcode+=code[j]
                    sock.sendto(mcode.encode('utf-8'), (host, port)) # 自動データ送信
                    print(mcode,"が自動送信されました")
                elif index[2]==0:
                    index[27]=0
                    drawLabel(27)
                    index[30]=0
                    drawLabel(30)
                    item[28][0]="００００００"
                    drawLabel(28)
                    item[31][0]="００００００"
                    drawLabel(31)
            if event.type == MOUSEBUTTONUP:  # マウスをクリックしたとき
                for k in activeButton: 
                    if buttonRect[k].collidepoint(event.pos):
                        if (4<=k and k<=32) and index[2]==0: break # When auto control 
                        if DEBUG==1: print("ボタン",k,"が押されました")
                        indexUpdate(k)
                        if k==35:
                            if DEBUG==1: print("自動／手動ボタンが押されました")
                            index[2]=1-index[2]
                            drawLabel(2)
                            index[29]=0
                            drawLabel(29)
                            index[32]=0
                            drawLabel(32)                             
                        if k==29:
                            notice1=item[27][index[27]]+"　　　　　"
                            textColor1=textColor[27]
                            buttonColor1=buttonColor[27]
                            drawLabel(27)
                            if index[29]==0:
                                if DEBUG==1: print("お知らせ１を静止に切りかえました")
                            if index[29]==1:
                                if DEBUG==1: print("お知らせ１を連続に切りかえました")
                            if index[29]==2:
                                if DEBUG==1: print("お知らせ１を点滅に切りかえました")
                        if k==32:
                            notice2=item[30][index[30]]+"　　　　　"
                            textColor2=textColor[30]
                            buttonColor2=buttonColor[30]
                            drawLabel(30)
                            if index[32]==0:
                                if DEBUG==1: print("お知らせ２を静止に切りかえました")
                            if index[32]==1:
                                if DEBUG==1: print("お知らせ２を連続に切りかえました")
                            if index[32]==2:
                                if DEBUG==1: print("お知らせ２を点滅に切りかえました")    
                        if k==33:
                            if DEBUG==1: print("表示番号＋が押されました")
                            if snum<len(opeList)-3:
                                snum+=1
                                drawCurrentTime()
                                drawCurrentTrain(snum)
                                drawGuide1(snum)
                                drawGuide2(snum+1)
                                drawGuide3(snum+2)
                                drawTrainNumber(snum-1,40)
                                adjustTime()
                        if k==34:                                  
                            if DEBUG==1: print("表示番号ーが押されました") 
                            if snum>0:
                                snum-=1
                                drawCurrentTime()
                                drawCurrentTrain(snum)
                                drawGuide1(snum)
                                drawGuide2(snum+1)
                                drawGuide3(snum+2)
                                drawTrainNumber(snum-1,40)
                                adjustTime()
                        if k==36:
                            if DEBUG==1: print("データ送信が押されました")
                            mcode=""
                            for j in range(5):
                                mcode+=code[j]
                            if DEBUG==1: print(mcode,"が手動送信されました")   # 手動データ送信
                            sock.sendto(mcode.encode('utf-8'), (host, port))
                            pygame.time.wait(200)
        pygame.display.flip()
        clock.tick(30)
        

